# WH40k Character Manager v3.2 by Grego


# Spis treci:

1. Czym jest WH40k Character Manager?
2. Obsuga programu - uwagi natury oglnej
3. Szczegy funkcjonalnoci programu
4. FAQ
5. Historia aktualizacji
6. Przyszo projektu
7. Kontakt




# 1. Czym jest WH40k Character Manager?

	WH40k Character Manager jest nieoficjalnym programem majcym na celu uatwienie kreacji postaci i zarzdzaniami nimi w nastpujcych systemach:
	- Dark Heresy 2ed.,
	- Only War.,
	- konwersja Rogue Tradera (oparta na https://docs.google.com/document/d/1M2hzwyXYNXrkFNYrazSDwbiF_O-NlETOjm9FGLyhA9A).
	

# 2. Obsuga programu - uwagi natury oglnej

	Program NIE wymaga poczenia z internetem podczas codziennego uytkowania. Wszystkie dane o postaciach s przechowywane lokalnie, w pliku znajdujcym
	si w tym samym folderze, co plik wykonywalny aplikacji.
	Program ten zawiera w skondensowanej formie duo informacji dot. kreacji i rozwoju postaci, jednak nie wyklucza on koniecznoci zasigania informacji
	z podrcznikw do Dark Heresy 2ed., Only Wara, Rogue Tradera lub Deathwatcha.
	Moliwe jest synchronizowanie danych postaci z serwerem strony internetowej: https://wh40kchm.waw.pl. Umoliwia to:
	- edycj postaci z poziomu przegldarki,
	- atwe przenoszenie danych midzy rnymi komputerami,
	- uywanie serwera strony internetowej do trzymania kopii zapasowych postaci.
	W celu korzystania ze strony internetowej, niezbdne jest stworzenie konta (patrz sekcja 3.2.3.)
	Do aktualizacji aplikacji zalecane jest uywanie wewntrznego mechanizmu aktualizacji, ktry powinien poprawnie przenie dotychczasowe dane postaci do
	nowej wersji programu.
	Program umoliwia generowanie wypenionego PDF-a karty postaci. Obsugiwane s jedynie te PDF-y, ktre oryginalnie znajduj si w folderze aplikacji.
	Mona natomiast robi kopi tych PDF-w, wypenia je danymi ktrych program nie nadpisuje (np. sprztem postaci) i wybiera te kopie w programie jako
	pliki bazowe do wypenienia.
	Graczu - pamitaj, eby uywa programu w konsultacji ze swoim Mistrzem Gry! Program pozwala na wiele wyborw, ktre mog mie diametralny wpyw na
	Twoj posta (rozwinicia elitarne, mutacje itp.) i ktre powinny by zatwierdzane przez Mistrza Gry.
	

# 3. Szczegy funkcjonalnoci programu

	## 3.1. Menu "File"
	Menu "File" ma nastpujce opcje do wyboru:
	a) Open Character - pozwala otworzy do przegldania/edycji jedn z przygotowanych wczeniej postaci.
	b) New Character - pozwala stworzy now posta.
	c) Save Character - pozwala zapisa aktualnie edytowan posta.
	d) Delete Character - pozwala usun aktualnie edytowan posta.
	e) Generate PDF Sheet - pozwala wygenerowa kart postaci w postaci wypenionego pliku PDF.
	f) Talent Overview - pozwala przeglda dostpne w programie zestawy talentw.
	h) Creation Helpers - pozwala wykorzysta dostpne w programie panele pomocnicze do kreacji postaci.
	h) Settings - pozwala na przegldanie i edycj ustawie programu.
	
	### 3.1.1. Open Character
	Po wybraniu tej opcji, program wywietla list dostpnych postaci. Po zatwierdzeniu wyboru, program udostpnia w gwnym oknie zakadki
	z panelami dedykowanymi poszczeglnym sekcjom dot. postaci:
	- Non-Modifiable: Zawiera podstawowe informacje o postaci niedostpne do bezporedniej edycji, tj. wydane XP, Aptitude'y, wybory etapw z kreacji postaci.
	- XP-independent: Zawiera niezalene od XP edytowalne statystyki postaci, tj. punkty Szalestwa i Spaczenia czy choroby psychiczne.
	- Elite Advances: Zawiera dostpne dla postaci elitarne rozwinicia.
	- Characteristics: Zawiera tabel do zarzdzania rozwojem charakterystyk.
	- Skills: Zawiera stronicowan tabel do zarzdzania rozwojem umiejtnoci, z moliwoci sortowania i filtrowania.
	- Talents: Zawiera stronicowan tabel do zarzdzania rozwojem zdolnoci, z moliwoci sortowania i filtrowania.
	- Special Advances: Zawiera stronicowan tabel do zarzdzania mocami psionicznymi i rozkazami, z moliwoci sortowania i filtrowania.
	- Plans: Zawiera stronicowan tabel do zarzdzania planami rozwoju (tworzonymi w panelach "Characteristics", "Skills", "Talents" i "Special Advances").
	- Notes: Zawiera pole tekstowe do wasnych notatek zwizanych z postaci.
	- Changes History: Zawiera automatycznie aktualizujc si histori zmian postaci.
	Wiersze w panelach "Characteristics", "Skills" i "Talents" maj rny kolor zaleny od tego, ile pasujcych Aptitude'w zwizanych z reprezentowanym
	przez nie rozwojem posiada posta:
	- Zielony: 2 Aptitude'y.
	- ty: 1 Aptitude.
	- Czerwony: 0 Aptitude'w.
	
	### 3.1.2. New Character
	Po wybraniu tej opcji, program wywietla list dostpnych rodzajw kreacji postaci.
	Po zatwierdzeniu wyboru kreacji postaci, naley poda imi postaci.
	Po podaniu imienia postaci, naley dokona nastpnych wyborw charakterystycznych dla wybranego rodzaju kreacji postaci.
	Przez ca procedur kreacji postaci, z prawej strony okna pokazywane jest podsumowanie przedstawiajce dotychczasowe wybory.
	W przypadku wartoci liczbowych tj. ywotno czy wartoci charakterystyk, program daje moliwo wygenerowania wartoci losowych
	lub podania wartoci wasnorcznie.
	Po przejciu przez wszystkie etapy kreacji postaci, moliwa jest sytuacja w ktrej wynikowy zestaw Aptitude'w zawiera powtrzenia.
	W takim przypadku program da moliwo wyboru zastpczych Aptitude'w zgodnie ze standardowymi zasadami systemu.
	Po zakoczonej kreacji postaci, program zapisze lokalnie utworzon posta i udostpni w gwnym oknie zakadki z panelami dedykowanymi
	poszczeglnym sekcjom dot. postaci (patrz sekcja 3.1.1.)
	
	### 3.1.3. Save Character
	Gdy w gwnym oknie aplikacji otwarta jest posta, wybranie tej opcji spowoduje lokalne zapisanie danych postaci. Wikszo wprowadzanych zmian
	jest moliwa do odwrcenia poprzez odznaczenie ich w gwnym oknie. Gwnym wyjtkiem z elitarne rozwinicia - po ich zatwierdzeniu nie mona
	ich cofn; wszystkie wybory dokonane przed zatwierdzeniem elitarnego rozwinicia rwnie stan si nieodwracalne.
	
	### 3.1.4. Delete Character
	Gdy w gwnym oknie aplikacji otwarta jest posta, wybranie tej opcji spowoduje lokalne usunicie danych postaci.
	Operacja ta jest nieodwracalna.
	
	### 3.1.5. Generate PDF Sheet
	Gdy w gwnym oknie aplikacji otwarta jest posta, wybranie tej opcji spowoduje otwarcie okna generacji karty postaci w formie pliku PDF.
	W oknie tym dostpne s nastpujce opcje pozwalajce dostosowa proces generacji karty do swoich potrzeb:
	a) Fill changeable data - nanosi na kart wartoci, ktre mog si w przyszoci zmieni, np. wartoci charakterystyk. Domylnie wczone.
	b) Use default PDF template / Choose PDF template - pozwala wybra plik PDF wypeniany przez program. UWAGA - ta opcja suy tylko 
	i wycznie do tego, eby nanosi zmiany na wstpnie wypenion kart postaci (np. z wpisanymi przedmiotami). Podstawowym plikiem rdowym
	karty postaci musi by:
	- W przypadku postaci do systemu Only War: plik Only_War_PC_Sheet.pdf.
	- W pozostaych przypadkach: plik Dark_Heresy_PC_Sheet.pdf.
	Pliki te znajduj si w folderze programu i nie naley ich stamtd usuwa.
	c) Order talents (By acquire time / By name) - pozwala wybra sposb sortowania talentw.
	
	### 3.1.6. Talent Overview
	Po wybraniu tej opcji, program wywietla list dostpnych zestaww talentw. Po zatwierdzeniu wyboru, program udostpnia w osobnym oknie
	stronicowan tabel do przegldania talentw, z moliwoci sortowania i filtrowania.
	Powysze okno nie blokuje reszty aplikacji i mona je zostawi w formie interaktywnej w trakcie tworzenia postaci.
	
	### 3.1.7. Creation Helpers
	Po wybraniu tej opcji, program wywietla okno z panelami pomocnicznymi do tworzenia postaci. Na ten moment dostpne s dwa:
	- Aptitudes: Pozwala odfiltrowa te kombinacje wyborw w kreacji postaci, ktre zapewniaj wybrane Aptitude'y.
	- Tags: Pozwala znale wybory w kreacji postaci poprzez wyszukiwanie po tagach - wietne dla tych, ktrzy chc stworzy posta bardziej "fabularnie".
	Powysze okno nie blokuje reszty aplikacji i mona je zostawi w formie interaktywnej w trakcie tworzenia postaci.

	### 3.1.8. Settings
	Po wybraniu tej opcji, program wywietla okno z dostpnymi ustawieniami aplikacji. S to:
	- RowsPerPage - maksymalna liczba wierszy pokazywana na jednej stronie w tabelach umiejtnoci, zdolnoci, planw, mocy psionicznych i rozkazw.
	- Username - nazwa uytkownika wykorzystywana przy synchronizacji danych z zewntrznym serwerem postaci. Konto uytkownika musi zosta
	wczeniej utworzone. Wicej informacji na ten tematznajduje si w sekcji 3.2.
	- Password - haso uytkownika wykorzystywane przy synchronizacji danych z zewntrznym serwerem postaci. Konto uytkownika musi zosta
	wczeniej utworzone. Wicej informacji na ten temat znajduje si w sekcji 3.2.
	- RememberLastCharacter - po zaznaczeniu tej opcji, program przy zamykaniu bdzie zapamitywa ostatni otwart posta, by otworzy j
	przy nastpnym starcie programu.
	- MasterMode - po zaznaczeniu tej opcji, aplikacja przechodzi w tryb, w ktrym postacie mog by edytowane w szerszym zakresie, bez rozdawania XP.
	Ma to na celu moliwo zastosowania zmian niewynikajcych ze standardowego rozwoju postaci (np. na danie MG). Po powrocie do zwykego trybu,
	wszystkie zmiany wprowadzone w trakcie i przed uruchomieniem MasterMode bd nieodwracalne w zwykym trybie.
	- MainScreenHeight - wysoko okna gwnego aplikacji (w pikselach).

	## 3.2. Menu "Remote"
	Menu "Remote" ma nastpujce opcje do wyboru:
	a) Upload - pozwala wysa lokalne dane postaci na serwer zdalny.
	b) Download - pozwala cign z serwera dane postaci i zapisa je lokalnie.
	b) Create account - pozwala stworzy konto uytkownika na serwerze zdalnym i zapisa lokalnie jego dane logowania lokalnie.
	
	### 3.2.1. Upload
	Do poprawnego uycia tej opcji, niezbdne jest zapewnienie poczenia z internetem oraz wpisanie nazwy uytkownika ("Username") i hasa ("Password")
	w ustawieniach aplikacji (patrz sekcja 3.1.8.)
	Po wybraniu tej opcji, program wywietla okno konfiguracji wysyania danych postaci na serwer zdalny. Dostpne s nastpujce opcje:
	 - Update locally changed characters - wysya i zapisuje na serwerze zmiany w postaciach, ktre obecne s zarwno na serwerze, jak i lokalnie.
	 - Add characters created locally - dodaje na serwer lokalne postacie, ktrych na serwerze brakuje.
	 - Delete characters removed locally - usuwa z serwera postacie, ktrych nie ma w danych lokalnych.
	Po zatwierdzeniu wybranych opcji przyciskiem "Perform", zostan wykonane odpowiednie operacje na serwerze. S one nieodwracalne.
	 
	### 3.2.2. Download
	Do poprawnego uycia tej opcji, niezbdne jest zapewnienie poczenia z internetem oraz wpisanie nazwy uytkownika ("Username") i hasa ("Password")
	w ustawieniach aplikacji (patrz sekcja 3.1.8.)
	Po wybraniu tej opcji, program wywietla okno konfiguracji pobierania danych postaci z serwera zdalnego. Dostpne s nastpujce opcje:
	- Update remotely changed characters - pobiera i zapisuje lokalnie zmiany w postaciach, ktre obecne s zarwno na serwerze, jak i lokalnie.
	- Add characters created remotely - dodaje do danych lokalnych postacie z serwera, ktrych lokalnie brakuje.
	- Delete characters removed remotely - usuwa z danych lokalnych postacie, ktrych nie ma na serwerze.
	Po zatwierdzeniu wybranych opcji przyciskiem "Perform", zostan wykonane odpowiednie operacje na danych lokalnych. S one nieodwracalne.
	
	### 3.2.3. Create account
	Do poprawnego uycia tej opcji, niezbdne jest zapewnienie poczenia z internetem.
	Po wybraniu tej opcji, program wywietla okno do wprowadzenia danych dla nowego konta uytkownika.
	Po wprowadzeniu poprawnych danych i ich zatwierdzeniu, konto zostaje utworzone na serwerze zdalnym. Ponadto, dane logowania tego uytkownika
	zostan automatycznie zapisane w lokalnych ustawieniach aplikacji - nie ma potrzeby wprowadzania tych danych ponownie.
	Od momentu zakoczenia powyszych operacji:
	- aplikacja jest gotowa do uycia opcji "Upload" i "Download" dla utworzonego konta,
	- mona zalogowa si na https://wh40kchm.waw.pl na nowo utworzone konto,
	- (po uprzednim skorzystaniu z opcji "Upload" - patrz sekcja 3.2.1) mona edytowa postacie z poziomu przegldarki.

	## 3.3. Menu "Help"
	Menu "Help" ma nastpujce opcje do wyboru:
	a) Check for update - pozwala sprawdzi, czy dostpne s aktualizacje dla managera i cign je, jeeli takowe znajdzie.
	b) About application - prezentuje podstawowe informacje o aplikacji.
	
	### 3.3.1. Check for update
	Do poprawnego uycia tej opcji, niezbdne jest zapewnienie poczenia z internetem.
	Po wybraniu tej opcji, manager sprawdzi czy dostpna jest aktualizacja do cignicia i poinformuje o wyniku. Jeeli aktualizacja
	bdzie dostpna, manager da moliwo jej cignicia.
	Po zatwierdzeniu wyboru, manager cignie aktualizacj i da moliwo wyboru jej instalacji.
	Po zatwierdzeniu wyboru, manager przeinstaluje si i uruchomi ponownie.	


# 4. FAQ

	## Kim jeste, autorze?
	
	Jestem Grego, czowiek z pasj do bycia Mistrzem Gry. Od wielu lat intensywnie prowadz sesje w systemach WH40k od FFG i bazujcych
	na nich konwersjach. W tym momencie mona mnie uzna za bardzo dowiadczonego MG w zakresie Dark Heresy 2ed. oraz Rogue Tradera,
	z duym dowiadczeniem w Only War, a take obeznanym z konwersj Deathwatcha na mechanik DH 2ed. Moim drugim hobby
	jest programowanie, co zreszt uskuteczniam rwnie zawodowo.
	
	## Czy program uwzgldnia ca mechanik kreacji i rozwoju postaci w systemie DH 2ed.?
	
	Na obecn chwil program powinien uwzgldnia ca wspomnian mechanik DH 2ed. poza "Malignancies" i Pochodzeniami z dodatkowych
	podrcznikw bdcymi konkretnymi planetami (np. Kalto z podrcznika Enemies Within).
	
	## Czy program uwzgldnia ca mechanik kreacji i rozwoju postaci w systemie Only War?
	
	Na obecn chwil program powinien uwzgldnia ca wspomnian mechanik Only War poza "Malignancies" i "Veteran Talents".
	
	## Czym si kierujesz przy projektowaniu, tworzeniu i rozwijaniu tego managera?
	
	Staram si spenia potrzeby i uwzgldnia uwagi rnych podmiotw, ktrych priorytet jest dla mnie nastpujcy:
	1. Ja.
	2. Moi gracze.
	3. Polska spoeczno WH40k.
	4. Reszta wiata.
	
	## Dlaczego nie uwzgldnie "Malignancies"? Czy dodasz je do programu w najbliszej przyszoci?

	Nie uwzgldniem ich, bo nie uywam ich w tej formie na swoich sesjach. Nie planuj ich doda w najbliszej przyszoci.
	Efekty "Malignancies" mona zasymulowa, wykonujc odpowiednie operacje z wczonym trybem MasterMode (patrz sekcja 3.1.8).
	
	## [DH 2ed.] Dlaczego nie uwzgldnie Pochodze w postaci nazwanych planet? Czy dodasz je do programu w najbliszej przyszoci?

	Nie uwzgldniem ich, bo prowadzone przeze kampanie dziej si w moim autorskim sektorze. Dodanie ich nie jest dla mnie istotne,
	ale moliwe e niedugo dodam je przy okazji, jeeli spoeczno wyrazi tym zainteresowanie.
	
	## [OW] Dlaczego nie uwzgldnie "Veteran Talents"? Czy dodasz je do programu w najbliszej przyszoci?

	Nie uwzgldniem ich, bo na ten moment uznaem e dodanie ich wprowadzi wicej zamieszania ni poytku (gwnie ze wzgldu
	na konieczno spenienia "Battlefield Requirement"). Dodanie ich nie jest dla mnie istotne, ale moliwe e niedugo dodam 
	je przy okazji, jeeli spoeczno wyrazi tym zainteresowanie.
	
	## [OW] W kreacji postaci brakuje etapu "Special Equipment Doctrines".
	
	Zgadza si, wiadomie nie dodawaem tego etapu, poniewa te wybory dotycz jedynie sprztu, ktry na ten moment nie jest
	obsugiwany przez managera.
	
	## [OW] Dlaczego postacie z grupy "Support Speciality" maj wpisane 300 XP jako wydane na start?
	
	eby wyrwna ze startowym 600 XP dla pozostaych postaci, na potrzeby sprawdzania przekroczenia progu moliwej zmiany specjalizacji.
	
	## Podczas kreacji postaci popeniem bd. Czy musz zrobi posta od nowa, eby go naprawi?
	
	Tak.
	
	## Czy moliwe jest usunicie wiersza ze specjalistyczn umiejtnoci/zdolnoci stworzonego przez przypadek i/lub z bdem?
	
	Nie. Moesz nie zaznacza tej umiejtnoci/zdolnoci jako kupionej, lecz powicony jej wiersz ju na zawsze pozostanie jako
	symbol Twojej poraki.
	
	## Czy planujesz dodanie zarzdzania przedmiotami do managera?
	
	Tak, ale nie w najbliszej przyszoci.
	
	## Jak mam gwarancj, e kreacja postaci z uyciem tego managera jest zgodna z podrcznikami?
	
	Nie jestem w stanie da komukolwiek takiej gwarancji. Mog tylko rczy za swoje dowiadczenie w systemach WH40k od FFG oraz w programowaniu,
	co oczywicie o niczym nie przesdza. Jeli zauwaysz bd w aplikacji - powiadom mnie (patrz sekcja 7.), a postaram si go naprawi!
	
	## Mam uwagi do graficznego interfejsu uytkownika w managerze...
	
	Moesz mi je przedstawi. Natomiast uczciwie przyznam, e szanse na ich uwzgldnienie przeze mnie s w najlepszym razie umiarkowane.
	Powody:
	a) Mam swoje wasne priorytety w trakcie prac nad managerem.
	b) Nie jestem profesjonalnym programist od graficznego interfejsu uytkownika i nigdy nie bd.
	c) Jestem gorcym zwolennikiem Pierwszej Zasady Inyniera: "Dziaa - nie rusza. Lepsze jest wrogiem dobrego."
	
	## Czy przegldarkowa wersja character managera ma tak sam funkcjonalno jak aplikacja okienkowa?
	
	Nie. Wersja przegldarkowa na ten moment pozwala jedynie na zarzdzanie ju stworzon postaci. Inne funkcje nie s dostpne, w szczeglnoci:
	- Tworzenie nowej postaci. Aby stworzy now posta i edytowa j z poziomu przegldarki, musisz zrobi j w aplikacji okienkowej,
	a nastpnie wysa na serwer zdalny (patrz sekcja 3.2.1.)
	- Tryb MasterMode.
	- Generowanie PDF-a postaci.
	Niektre z brakujcych funkcji s rozwaane do dodania w wersji przegldarkowej. Nie mog da jednak adnych gwarancji, czy i kiedy to tego dojdzie.
	
	## Czy masz zamiar doda do managera kreacj postaci do innych systemw WH40k od FFG?
	
	Nie. Jestem zainteresowany jedynie systemami opartymi o Predyspozycje (Aptitudes).
	
	## Czy masz zamiar doda do managera kreacj postaci do popularnych konwersji/fanowskiej twrczoci opartej o systemy WH40k od FFG?
	
	Problem polega na tym, e trudno jednoznacznie okreli, czy dana konwersja jest popularna. Sam kilku konwersji uywam i w wersji managera
	przeznaczonej dla moich graczy zamieciem kreacj do nich, ale zawarem w nich rwnie swoje autorskie zmiany.
	Jeeli wrd spoecznoci bdzie due zainteresowanie konkretn konwersj, to rozwa dodanie do managera kreacji postaci do niej.
	
	## Czy masz zamiar doda do managera kreacj postaci do systemu Wrath & Glory?
	
	Nie. Jestem zainteresowany tylko systemami WH40k od FFG. Powstaj i s rozwijane inne wspaniae fanowskie narzdzia do W&G.
	
	## Czy projekt Twojej aplikacji jest dostpny publicznie na Github, Bitbucket etc.?
	
	Nie. Jest to prywatny projekt na Bitbucket i nie planuj tego zmienia. Powody ku temu rwnie zostawi dla siebie.
	
	## Czy jest moliwo wsparcia Twojego projektu jako programista?
	
	Nie planuj dzielenia si prac nad managerem w obecnej postaci. Niektre z powodw to:
	a) Projekt programu pragn zastrzec dla siebie.
	b) Wystarczy mi kontaktu z ludmi w pracy i na sesjach RPG.
	c) Jestem gorcym zwolennikiem powiedzenia "Umiesz liczy - licz na siebie".

	## Czy planowane jest wydanie programu w wersji spolszczonej?
	
	Moe, kiedy, dziki pomocy osb trzecich.
	

# 5. Historia aktualizacji

	Wersja 1.0:
		Pierwsza udostpniona wersja programu.
	Wersja 1.1:
		Poprawiono mechanizm aktualizacji.
	Wersja 1.2:
		Poprawiono wydajno aplikacji.
	Wersja 1.3:
		Poprawiono wydajno aplikacji.
	Wersja 1.4:
		Poprawiono wydajno aplikacji.
	Wersja 1.5:
		- Dodano moliwo umieszczania komentarzy przy planach rozwoju.
		- Dodano moliwo filtrowania kupionych/niekupionych umiejtnoci/zdolnoci/mocy.
		- Dodano czas wygenerowania karty postaci do nazwy PDF-a.
		- Poprawiono wygld paneli kreacji postaci.
	Wersja 1.6:
		Dodano moliwo ustawienia liczby wierszy w panelach rozwoju postaci.
	Wersja 1.7:
		Dodano awans elitarny "Sister of Battle".
	Wersja 1.8:
		- Zwikszono moliwoci filtrowania umiejtnoci/zdolnoci/mocy.
		- Dodano informowanie uytkownika o problemach z poczeniem internetowym podczas aktualizacji.
	Wersja 1.9:
		- Dodano przycisk do resetowania filtrw.
		- Poprawiono filtrowanie specjalistycznych zdolnoci i umiejtnoci.
	Wersja 1.10:
		Poprawiono wydajno aplikacji.
	Wersja 1.11:
		Dodano moliwo kreacji i zarzdzania postaciami do systemu Only War (bez Advanced Specialities).
	Wersja 1.12:
		Poprawiono sprawdzanie wymaga dla talentw ze specjalizacjami.
	Wersja 1.13:
		- Zrefaktoryzowano zapis i odczyt danych postaci.
		- Dodano mechanizm Advanced Specialities do zarzdzania postaciami w systemie Only War.
		- Zoptymalizowano dziaanie interfejsu uytkownika.
	Wersja 1.14:
		Umoliwiono przechowywanie danych postaci na serwerze zdalnym i synchronizowanie danych lokalnych z serwerem.
	Wersja 1.15:
		- Poprawiono pobieranie Elite Advances z serwera zdalnego.
		- Poprawiono wczytywanie postaci Only War.
	Wersja 1.16:
		- Dodano moliwo wybrania pliku PDF do wypenienia przy generowaniu PDF-a postaci.
		- Dodano moliwo wybrania, czy program ma do PDF-a wpisywa dane postaci, ktre mog w przyszoci si zmieni.
		- Dodano moliwo wybrania, czy talenty w PDF-ie maj by posortowane po nazwie, czy w kolejnoci ich uzyskania.
		- Dodano MasterMode, w ktrym mona dowolnie edytowa wszystkie waciwoci graczy na danie MG.
		- Poprawiono wysyanie danych do serwera zdalnego w sytuacji, gdy uytkownik zapomnia sam zapisa danych lokalnie.
		- Poprawiono obsug planw dla talentw, ktre mona wzi wicej ni jeden raz.
		- Naprawiono niepotrzebne robienie backupu pliku z danymi przy uzupenianiu nazwy uytkownika po raz pierwszy.
		- Poprawiono kilka maych problemw zwizanych z prezentacj graficzn niektrych danych.
	Wersja 1.17:
		- Dodano panel przegldania dostpnych talentw odseparowany od konkretnej postaci.
		- Zmniejszono wysoko wierszy tabel z danymi.
		- Dodano customowy homeworld dla DH2 - Imperial World.
		- Przeredagowano moliwe opcje w ramach kreacji postaci do RT.
		- Sprawionio, e wysoko gwnego okna aplikacji jest teraz ustalana na poziomie ustawie aplikacji (opcja "Settings")
		- Sprawionio, e Leadership jest teraz traktowany jako moliwy 2. Aptitude dla charakterystyki Willpower.
	Wersja 1.18:
		- Dodano zakadk do robienia notatek dot. postaci.
		- Dodano wysyanie emaila do twrcy programu w momencie wystpienia nieobsugiwanego bdu, zawierajcego szczegy bdu.
		- Poprawiono wywietlanie filtrw przy mocach psionicznych.
		- Naprawiono buga zwizanego z zapisywaniem postaci po wykupieniu elitarnego awansu.
		- Naprawiono buga zwizanego z wywietlaniem niepoprawnych statystyk postaci po zapisaniu postaci na serwerze zdalnym.
		- Naprawiono buga zwizanego z wywietlaniem mocy psionicznych przy kreacji postaci psionika w systemie Only War.
	Wersja 1.19:
		- Naprawiono buga zwizanego z obsug elitarnego awansu Astropath.
	Wersja 1.20:
		- Dodano automatyczne sprawdzanie (przy prbie zmiany postaci/zamknicia aplikacji), czy aktualnie otwarta posta ma niezapisane zmiany.
		- Dodano (jako talenty) specjalne rozkazy z podrcznika "Shield of Humanity" do rozwoju postaci w systemie Only War.
	Wersja 1.21:
		- Dodano moliwo zapamitania ostatnio otwieranej postaci.
		- Poprawiono automatyczne sprawdzanie, czy aktualnie otwarta posta ma niezapisane zmiany.
		- Poprawiono struktur bazy danych.
		- Poprawiono dostosowywanie zawartoci okna do jego rozmiaru.
		- Zrefaktoryzowano kod odpowiedzialny za komunikacj z baz danych i generowanie plikw PDF.
	Wersja 1.22:
		- Poprawiono automatyczne sprawdzanie, czy aktualnie otwarta posta ma niezapisane zmiany.
	Wersja 1.23:
		- Dodano pierwsz wersj kreacji postaci do konwersji systemu Deathwatch.
		- Rozszerzono plik README w wersji polskiej.
		- Dodano plik README w wersji angielskiej.
	Wersja 1.24:
		Poprawiono sprawdzanie wymaga do talentw.
	Wersja 2.0:
		- Dodano moliwoc synchronizacji danych ze stron internetow https://wh40kchm.waw.pl
		- Dodano automatycznie aktualizujc si histori zmian postaci, moliw do przegldania w osobnym panelu podczas edycji postaci.
		- Dodano panele pomocnicze do kreacji postaci.
		- Znacznie poprawiono wydajno aplikacji.
		- Poprawiono automatyczne sprawdzanie, czy aktualnie otwarta posta ma niezapisane zmiany.
		- Naprawiono pomniejsze bdy przy kreacji postaci.
		- Naprawiono pomniejsze bdy przy zarzdzaniu planami.
		- Poprawiono wywietlanie wielu elementw graficznego interfejsu uytkownika.
	Wersja 2.1:
		- Poprawiono wydajno sprawdzania wymaga talentw (wykonywan automatycznie praktycznie przy kadej zmianie na postaci).
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.2:
		- Dodano moliwo zmiany liczby Fate Pointw w Master Mode.
		- Poprawiono wydajno zarzdzania planami.
		- Poprawiono wydajno sortowania i aplikowania filtrw.
		- Naprawiono problem z wykonywaniem wieo dodanych planw.
		- Naprawiono generowanie domylnych wartoci charakterystyk przy tworzeniu postaci.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.3:
		- Dodano dwie nowe opcje kreacje postaci typu "RT2".
		- Poprawiono wydajno zarzdzania mocami psionicznymi / rozkazami.
		- Usunito niepotrzebne pokazywanie informacji o wymaganiach mocy psionicznych w Master Mode.
		- Naprawiono problem z anulowaniem procesu kreacji postaci.
		- Poprawiono kilka literwek.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.4:
		- Poprawiono wydajno zarzdzania umiejtnociami.
		- Naprawiono problem z brakiem weryfikacji posiadanego XP do wykupienia awansu charakterystyki.
		- Naprawiono rzadki problem z tworzeniem postaci w Only War.
		- Naprawiono problem z odblokowywaniem przyciskw do dodawania planw.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.5:
		- Naprawiono problem z wczytywaniem postaci zawierajcych plany dla umiejtnoci.
	Wersja 2.6:
		- Poprawiono wydajno wczytywania aplikacji i procesowania wyboru wikszoci opcji z menu aplikacji.
		- Poprawiono wizualny aspekt tworzenia zakadek w gwnym oknie kiedy np. wczytywana jest wybrana posta.
		- Poprawiono graficzny interfejs zarzdzania ustawieniami aplikacji.
		- Wyczono opcj zapisu postaci i generowania pliku PDF gdy adna posta nie jest otwarta.
		- Naprawiono niepoprawn moliwo wybrania ponownie tej samej mutacji oraz malignancy.
		- Naprawiono blokowanie gwnego okna aplikacji podczas kreacji nowej postaci.
		- Naprawiono pokazywanie wybranego rodzaju kreacji postaci w panelu podsumowujcym podjte wybory.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.7:
		- Naprawiono aplikowanie efektw wczenia/wyczenia Master Mode podczas dziaania aplikacji.
		- Poprawiono wysyanie wiadomoci e-mail do autora aplikacji w przypadku wystpienia niespodziewanego bdu
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 2.8:
		- Naprawiono bd przy pokazywaniu historii zmian postaci ktra wykupowaa kiedy awanse specjalne (moce psioniczne lub rozkazy).
		- Naprawiono bd przy zaktualizowaniu aplikacji.
		- Naprawiono wysyanie wiadomoci e-mail do autora aplikacji w przypadku wystpienia niespodziewanego bdu.
	Wersja 2.9:
		- Zunifikowano kilka aspektw graficznego interfejsu kreacji postaci.
		- Poprawiono odwieanie zawartoci okien kreacji postaci.
		- Naprawiono bd przy odznaczaniu najwyszego rozwinicia umiejtnoci.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 3.0:
		- Poprawiono wydajno aplikacji.
		- Poprawiono obsug nadmiarowych umiejtnoci specjalistycznych podczas generowania PDF-a karty postaci.
		- Naprawiono problem z nieprawidowym stanem aplikacji po wysaniu danych postaci na serwer zdalny.
		- Usunito niepotrzebne okna informacyjne przy wysyaniu danych postaci na serwer zdalny.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 3.1:
		- Sprawiono, e panel historii zmian otwartej postaci odwiea si przy kadym zapisaniu zmian.
		- Zwikszono maksymaln dugo linii tekstu, ktre aplikacja moe zapisa w spisie talentw na karcie postaci (PDF).
		- Wprowadzono drobne zmiany przy zarzdzaniu ustawieniami aplikacji.
		- Poprawiono bdy w opisach niektrych talentw.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
	Wersja 3.2:
		- Dodano weryfikowanie chorb psychicznych wprowadzanych podczas kreacji postaci.
		- Naprawiono kilka pomniejszych problemw z graficznym interfejsem uytkownika.
		- Wykonano refaktoryzacj kodu programu, co powinno przeoy si na jego atwiejszy rozwj i utrzymanie.
		

# 6. Przyszo projektu

	W najbliszej przyszoci planuj dalej refaktoryzowa kod.
	W nastpnej kolejnoci planuj doda obsug przedmiotw.
	W nastpnej kolejnoci rozwa przepisanie aplikacji w taki sposb, aby bya dostpna na systemach operacyjnych innych ni Windows.
	W midzyczasie postaram si uwzgldnia uwagi uytkownikw dotyczce managera.
	
	
# 7. Kontakt

	Skontaktowa mona si ze mn nastpujcymi kanaami:
	a) E-mail: grego.wh40k@gmail.com
	b) Reddit: u/Grego_from_Qinoth
	